from __init__ import db, login_manager, login_serializer, cookie_duration

@login_manager.user_loader
def user_loader(user_id):
    return User.query.get(user_id)


@login_manager.request_loader
def load_token(request):
    """
    Flask-Login token_loader callback.
    The token_loader function asks this function to take the token that was
    stored on the users computer process it to check if its valid and then
    return a User Object if its valid or None if its not valid.
    """

    #The Token itself was generated by User.get_auth_token.  So it is up to
    #us to known the format of the token data itself.

    #The Token was encrypted using itsdangerous.URLSafeTimedSerializer which
    #allows us to have a max_age on the token itself.  When the cookie is stored
    #on the users computer it also has a exipry date, but could be changed by
    #the user, so this feature allows us to enforce the exipry date of the token
    #server side and not rely on the users cookie to exipre.
    max_age = cookie_duration

    #Decrypt the Security Token, data = [username, hashpass]
    token = request.args.get('token')
    if not token:
        return None
    data = login_serializer.loads(token, max_age=max_age)

    #Find the User
    user = User.query.get(data[0])

    #Check Password and return user or None
    if user and data[1] == user.password:
        return user
    return None


class User(db.Model):
    id = db.Column(db.Integer, primary_key=True) # primary keys are required by SQLAlchemy
    username = db.Column(db.String(100), unique=True)
    password = db.Column(db.String(100))
    is_active = db.Column(db.Boolean)
    is_admin = db.Column(db.Boolean)
    admin_id = db.Column(db.Integer, db.ForeignKey(id, ondelete="CASCADE"))
    admin = db.relationship('User', remote_side='User.id', backref='patients', cascade="all, delete")
    is_authenticated = db.Column(db.Boolean)
    created_at = db.Column(db.DateTime(timezone=True),
                           server_default=db.func.now())
    def to_json(self):
        return {"username": self.username, "is_admin": self.is_admin, "admin_id": self.admin_id}

    def is_authenticated(self):
        return self.is_authenticated

    def is_active(self):
        return self.is_active

    def is_anonymous(self):
        return False

    def get_id(self):
        return str(self.id)

    def get_auth_token(self):
        """
        Encode a secure token for cookie
        """
        data = [str(self.id), self.password]
        return login_serializer.dumps(data)


class Results(db.Model):
    # __bind_key__ = "results"
    id = db.Column(db.Integer, primary_key=True)    # primary keys are required by SQLAlchemy
    username = db.Column(db.String(100))            # not unique as a single user may run the tests multiple times
    date = db.Column(db.Text)
    session_id = db.Column(db.Integer)

    average_utterance_length = db.Column(db.Float)
    verbs_words_ratio = db.Column(db.Float)
    nouns_words_ratio = db.Column(db.Float)
    adjectives_words_ratio = db.Column(db.Float)
    adverbs_words_ratio = db.Column(db.Float)
    conjuctions_words_ratio = db.Column(db.Float)
    prepositions_words_ratio = db.Column(db.Float)
    words_per_minute = db.Column(db.Float)
    verbs_per_utterance = db.Column(db.Float)
    unique_words_per_words = db.Column(db.Float)
    nouns_verbs_ratio = db.Column(db.Float)
    open_close_class_ratio = db.Column(db.Float)
    mean_clauses_per_utterance = db.Column(db.Float)
    mean_dependent_clauses = db.Column(db.Float)
    mean_independent_clauses = db.Column(db.Float)
    dependent_all_clauses_ratio = db.Column(db.Float)
    mean_tree_height = db.Column(db.Float)
    max_tree_depth = db.Column(db.Float)
    n_independent = db.Column(db.Float)
    n_dependent = db.Column(db.Float)
    propositional_density = db.Column(db.Float)
    words_in_vocabulary_per_words = db.Column(db.Float)
    unique_words_in_vocabulary_per_words = db.Column(db.Float)
    determiners_words_ratio = db.Column(db.Float)
    pronouns_words_ratio = db.Column(db.Float)
    # interjections_words_ratio = db.Column(db.Float)
    WAB_AQ = db.Column(db.Float)
    aphasia_type = db.Column(db.String(50))
    WAB_AQ_category = db.Column(db.String(50))
    number_of_words = db.Column(db.Integer)
    completed = db.Column(db.Boolean, default=False)
    created_at = db.Column(db.DateTime(timezone=True),
                           server_default=db.func.now())
    stories = db.relationship('Story', backref='results')
    # https://stackoverflow.com/questions/10059345/sqlalchemy-unique-across-multiple-columns
    __table_args__ = (db.UniqueConstraint('id', 'username', name='_id_username_uc'),)
    def to_dict(self):
        return {c.key: getattr(self, c.key) for c in db.inspect(self).mapper.column_attrs}

class Story(db.Model):
    id = db.Column(db.Integer, primary_key=True)    # primary keys are required by SQLAlchemy
    results_id = db.Column(db.Integer, db.ForeignKey('results.id'))
    name = db.Column(db.String(50))
    date = db.Column(db.Text)
    average_utterance_length = db.Column(db.Float)
    verbs_words_ratio = db.Column(db.Float)
    nouns_words_ratio = db.Column(db.Float)
    adjectives_words_ratio = db.Column(db.Float)
    adverbs_words_ratio = db.Column(db.Float)
    conjuctions_words_ratio = db.Column(db.Float)
    prepositions_words_ratio = db.Column(db.Float)
    words_per_minute = db.Column(db.Float)
    verbs_per_utterance = db.Column(db.Float)
    unique_words_per_words = db.Column(db.Float)
    nouns_verbs_ratio = db.Column(db.Float)
    open_close_class_ratio = db.Column(db.Float)
    mean_clauses_per_utterance = db.Column(db.Float)
    mean_dependent_clauses = db.Column(db.Float)
    mean_independent_clauses = db.Column(db.Float)
    dependent_all_clauses_ratio = db.Column(db.Float)
    mean_tree_height = db.Column(db.Float)
    max_tree_depth = db.Column(db.Float)
    n_independent = db.Column(db.Float)
    n_dependent = db.Column(db.Float)
    propositional_density = db.Column(db.Float)
    words_in_vocabulary_per_words = db.Column(db.Float)
    unique_words_in_vocabulary_per_words = db.Column(db.Float)
    determiners_words_ratio = db.Column(db.Float)
    pronouns_words_ratio = db.Column(db.Float)
    # interjections_words_ratio = db.Column(db.Float)
    number_of_words = db.Column(db.Integer)
    transcription = db.Column(db.String(1000))
    audio_name = db.Column(db.String(100))
    created_at = db.Column(db.DateTime(timezone=True),
                           server_default=db.func.now())
    def to_dict(self):
        return {c.key: getattr(self, c.key) for c in db.inspect(self).mapper.column_attrs}
